<html>
<body>
    <table style="width: 100%">
        <tr>
            <td>
                <button onclick="sortData()">Sort</button>
            </td>
            <td>
                <input id="nameFilter" placeholder="name">
            </td>
            <td>
                <button onclick="filterData()">Filter</button>
            </td>
        </tr>
    </table>

    <table style="width: 100%" border="1" id="list">
    </table>

<span id="err"></span>
    <script>
        var contactsString = HtmlAndroidBridge.getContactsAsJson();
        var contacts = JSON.parse(contactsString);
        var container = document.getElementById("list");
        var visibleRows = contacts;
        var orderAsc = true;

        setupTable();

        function sortData(){
            orderAsc = !orderAsc;
            if(orderAsc)
                visibleRows = visibleRows.sort((a, b) => (a.name > b.name) ? -1 : 1);
            else
                visibleRows = visibleRows.sort((a, b) => (a.name > b.name) ? 1 : -1);

            setupTable();
        }

        function filterData(){
            visibleRows = [];

            var name = document.getElementById("nameFilter").value ;
            if(name == null || name == "")
            {
                visibleRows = contacts;
                setupTable();
                return;
            }

            for(var i =0;i<contacts.length;i++)
            {
                if(contacts[i].name.toLowerCase().includes(name.toLowerCase())){
                    console.log(contacts[i].name.toLowerCase());
                    visibleRows.push(contacts[i]);
                }
            }
            setupTable();
        }

        function setupTable(){
            while (container.firstChild) {
                container.removeChild(container.firstChild);
            }

            for(var i =0;i<visibleRows.length;i++)
            {
                var row = document.createElement("tr");

                var tdId = document.createElement("td");
                tdId.innerText = visibleRows[i].id;
                row.appendChild(tdId);

                var tdName = document.createElement("td");
                tdName.innerText = visibleRows[i].name;
                row.appendChild(tdName);

                var tdNumber = document.createElement("td");
                tdNumber.innerText = visibleRows[i].number;
                row.appendChild(tdNumber);

                container.appendChild(row);
            }
        }
    </script>
    <script src="jquery.js"></script>
</body>

</html>